/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){var e=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/errors","vs/base/common/buffer","vs/base/common/functional","vs/base/parts/ipc/common/ipc","vs/base/common/cancellation","vs/base/common/process","vs/base/common/platform","vs/base/common/iterator","vs/base/common/async","vs/base/common/strings","vs/base/common/linkedList","vs/base/common/uuid","vs/base/common/path","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","net","os","vs/platform/driver/node/driver"],t=function(t){for(var n=[],s=0,i=t.length;s<i;s++)n[s]=e[t[s]];return n};define(e[4],t([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){
this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=n,t.errorHandler=new n,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},t.onUnexpectedError=function(e){i(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){i(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:n}=e;return{$isError:!0,name:t,message:n,stack:e.stacktrace||e.stack}}return e};const s="Canceled";function i(e){return e instanceof Error&&e.name===s&&e.message===s}t.isPromiseCanceledError=i,t.canceled=function(){const e=new Error(s);return e.name=e.message,e},t.illegalArgument=function(e){
return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};class r extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}}t.NotImplementedError=r})),define(e[6],t([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=function(e){const t=this;let n,s=!1;return function(){return s?n:(s=!0,n=e.apply(t,arguments))}}})),define(e[11],t([1,0]),(function(e,t){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.FIN={done:!0,value:void 0},function(e){const n={next:()=>t.FIN};e.empty=function(){
return n},e.single=function(e){let n=!1;return{next:()=>n?t.FIN:(n=!0,{done:!1,value:e})}},e.fromArray=function(e,n=0,s=e.length){return{next:()=>n>=s?t.FIN:{done:!1,value:e[n++]}}},e.fromNativeIterator=function(e){return{next(){const n=e.next();return n.done?t.FIN:{done:!1,value:n.value}}}},e.from=function(t){return t?Array.isArray(t)?e.fromArray(t):t:e.empty()},e.map=function(e,n){return{next(){const s=e.next();return s.done?t.FIN:{done:!1,value:n(s.value)}}}},e.filter=function(e,n){return{next(){for(;;){const s=e.next();if(s.done)return t.FIN;if(n(s.value))return{done:!1,value:s.value}}}}},e.forEach=function(e,t){for(let n=e.next();!n.done;n=e.next())t(n.value)},e.collect=function(e,t=Number.POSITIVE_INFINITY){const n=[];if(0===t)return n;let s=0;for(let i=e.next();!i.done&&(n.push(i.value),!(++s>=t));i=e.next());return n},e.concat=function(...e){let n=0;return{next(){if(n>=e.length)return t.FIN;const s=e[n].next();return s.done?(n++,this.next()):s}}}}(n=t.Iterator||(t.Iterator={})),
t.getSequenceIterator=function(e){return Array.isArray(e)?n.fromArray(e):e};class s{constructor(e,t=0,n=e.length,s=t-1){this.items=e,this.start=t,this.end=n,this.index=s}first(){return this.index=this.start,this.current()}next(){return this.index=Math.min(this.index+1,this.end),this.current()}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}}t.ArrayIterator=s;t.ArrayNavigator=class extends s{constructor(e,t=0,n=e.length,s=t-1){super(e,t,n,s)}current(){return super.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}parent(){return null}};class i{constructor(e,t){this.iterator=e,this.fn=t}next(){return this.fn(this.iterator.next())}}t.MappedIterator=i;t.MappedNavigator=class extends i{constructor(e,t){super(e,t),this.navigator=e}current(){return this.fn(this.navigator.current())}previous(){
return this.fn(this.navigator.previous())}parent(){return this.fn(this.navigator.parent())}first(){return this.fn(this.navigator.first())}last(){return this.fn(this.navigator.last())}next(){return this.fn(this.navigator.next())}}})),define(e[2],t([1,0,6]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s=!1,i="__is_disposable_tracked__";function r(e){if(s&&e&&e!==h.None)try{e[i]=!0}catch(e){}}function o(e){if(!s)return e;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[i]||console.log(t)},3e3),e}function c(e){return Array.isArray(e)?(e.forEach(e=>{e&&(r(e),e.dispose())}),[]):e?(r(e),e.dispose(),e):void 0}t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=c,t.combinedDisposable=function(...e){return e.forEach(r),o({dispose:()=>c(e)})},t.toDisposable=function(e){const t=o({dispose:()=>{r(t),e()}});return t};class a{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){
this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){this._toDispose.forEach(e=>e.dispose()),this._toDispose.clear()}add(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return r(e),this._isDisposed?console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}t.DisposableStore=a;class h{constructor(){this._store=new a,o(this)}dispose(){r(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});t.MutableDisposable=class{constructor(){this._isDisposed=!1,o(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&r(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,r(this),
this._value&&this._value.dispose(),this._value=void 0}};t.UnownedDisposable=class extends h{constructor(e){super(),this._hasBeenAcquired=!1,this._value=e}acquire(){if(this._hasBeenAcquired)throw new Error("This disposable has already been acquired");this._hasBeenAcquired=!0;const e=this._value;return this._value=void 0,e}dispose(){super.dispose(),this._hasBeenAcquired||(this._hasBeenAcquired=!0,this._value.dispose(),this._value=void 0)}};t.ReferenceCollection=class{constructor(){this.references=new Map}acquire(e){let t=this.references.get(e);t||(t={counter:0,object:this.createReferencedObject(e)},this.references.set(e,t));const{object:s}=t,i=n.once(()=>{0==--t.counter&&(this.destroyReferencedObject(e,t.object),this.references.delete(e))});return t.counter++,{object:s,dispose:i}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}})),define(e[14],t([1,0,11]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class s{constructor(e){this.element=e,
this.next=s.Undefined,this.prev=s.Undefined}}s.Undefined=new s(void 0);t.LinkedList=class{constructor(){this._first=s.Undefined,this._last=s.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===s.Undefined}clear(){this._first=s.Undefined,this._last=s.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const n=new s(e);if(this._first===s.Undefined)this._first=n,this._last=n;else if(t){const e=this._last;this._last=n,n.prev=e,e.next=n}else{const e=this._first;this._first=n,n.next=e,e.prev=n}this._size+=1;let i=!1;return()=>{i||(i=!0,this._remove(n))}}shift(){if(this._first!==s.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==s.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==s.Undefined&&e.next!==s.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===s.Undefined&&e.next===s.Undefined?(this._first=s.Undefined,
this._last=s.Undefined):e.next===s.Undefined?(this._last=this._last.prev,this._last.next=s.Undefined):e.prev===s.Undefined&&(this._first=this._first.next,this._first.prev=s.Undefined);this._size-=1}iterator(){let e,t=this._first;return{next:()=>t===s.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}toArray(){const e=[];for(let t=this._first;t!==s.Undefined;t=t.next)e.push(t.element);return e}}})),define(e[3],t([1,0,4,6,2,14]),(function(e,t,n,s,i,r){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),function(e){function t(e){return(t,n=null,s)=>{let i,r=!1;return i=e(e=>{if(!r)return i?i.dispose():r=!0,t.call(n,e)},null,s),r&&i.dispose(),i}}function n(e,t){return c((n,s=null,i)=>e(e=>n.call(s,t(e)),null,i))}function s(e,t){return c((n,s=null,i)=>e(e=>{t(e),n.call(s,e)},null,i))}function r(e,t){return c((n,s=null,i)=>e(e=>t(e)&&n.call(s,e),null,i))}function o(e,t,s){let i=s;return n(e,e=>i=t(i,e))}function c(e){let t;const n=new h({onFirstListenerAdd(){t=e(n.fire,n)
},onLastListenerRemove(){t.dispose()}});return n.event}function a(e,t,n=100,s=!1,i){let r,o=void 0,c=void 0,a=0;const l=new h({leakWarningThreshold:i,onFirstListenerAdd(){r=e(e=>{a++,o=t(o,e),s&&!c&&l.fire(o),clearTimeout(c),c=setTimeout(()=>{const e=o;o=void 0,c=void 0,(!s||a>1)&&l.fire(e),a=0},n)})},onLastListenerRemove(){r.dispose()}});return l.event}function l(e){let t,n=!0;return r(e,e=>{const s=n||e!==t;return n=!1,t=e,s})}e.None=()=>i.Disposable.None,e.once=t,e.map=n,e.forEach=s,e.filter=r,e.signal=function(e){return e},e.any=function(...e){return(t,n=null,s)=>i.combinedDisposable(...e.map(e=>e(e=>t.call(n,e),null,s)))},e.reduce=o,e.snapshot=c,e.debounce=a,e.stopwatch=function(e){const s=(new Date).getTime();return n(t(e),e=>(new Date).getTime()-s)},e.latch=l,e.buffer=function(e,t=!1,n=[]){let s=n.slice(),i=e(e=>{s?s.push(e):o.fire(e)});const r=()=>{s&&s.forEach(e=>o.fire(e)),s=null},o=new h({onFirstListenerAdd(){i||(i=e(e=>o.fire(e)))},onFirstListenerDidAdd(){s&&(t?setTimeout(r):r())},
onLastListenerRemove(){i&&i.dispose(),i=null}});return o.event};class u{constructor(e){this.event=e}map(e){return new u(n(this.event,e))}forEach(e){return new u(s(this.event,e))}filter(e){return new u(r(this.event,e))}reduce(e,t){return new u(o(this.event,e,t))}latch(){return new u(l(this.event))}debounce(e,t=100,n=!1,s){return new u(a(this.event,e,t,n,s))}on(e,t,n){return this.event(e,t,n)}once(e,n,s){return t(this.event)(e,n,s)}}e.chain=function(e){return new u(e)},e.fromNodeEventEmitter=function(e,t,n=(e=>e)){const s=(...e)=>i.fire(n(...e)),i=new h({onFirstListenerAdd:()=>e.on(t,s),onLastListenerRemove:()=>e.removeListener(t,s)});return i.event},e.fromDOMEventEmitter=function(e,t,n=(e=>e)){const s=(...e)=>i.fire(n(...e)),i=new h({onFirstListenerAdd:()=>e.addEventListener(t,s),onLastListenerRemove:()=>e.removeEventListener(t,s)});return i.event},e.fromPromise=function(e){const t=new h;let n=!1;return e.then(void 0,()=>null).then(()=>{n?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),n=!0,t.event},
e.toPromise=function(e){return new Promise(n=>t(e)(n))}}(o=t.Event||(t.Event={}));let c=-1;t.setGlobalLeakWarningThreshold=function(e){const t=c;return c=e,{dispose(){c=t}}};class a{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=c;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const n=(new Error).stack.split("\n").slice(3).join("\n"),s=this._stacks.get(n)||0;if(this._stacks.set(n,s+1),this._warnCountdown-=1,this._warnCountdown<=0){let n;this._warnCountdown=.5*t;let s=0;this._stacks.forEach((e,t)=>{(!n||s<e)&&(n=t,s=e)}),console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${s}):`),console.warn(n)}return()=>{const e=this._stacks.get(n)||0;this._stacks.set(n,e-1)}}}class h{constructor(e){this._disposed=!1,this._options=e,
this._leakageMon=c>0?new a(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=(e,t,n)=>{this._listeners||(this._listeners=new r.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(t?[e,t]:e);let c,a;return s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t),this._leakageMon&&(c=this._leakageMon.check(this._listeners.size)),a={dispose:()=>{if(c&&c(),a.dispose=h._noop,!this._disposed&&(o(),this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},n instanceof i.DisposableStore?n.add(a):Array.isArray(n)&&n.push(a),a}),this._event}fire(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new r.LinkedList)
;for(let t=this._listeners.iterator(),n=t.next();!n.done;n=t.next())this._deliveryQueue.push([n.value,e]);for(;this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){n.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0}}t.Emitter=h,h._noop=function(){};t.PauseableEmitter=class extends h{constructor(e){super(e),this._isPaused=0,this._eventQueue=new r.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray();this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}};t.AsyncEmitter=class extends h{async fireAsync(e){
if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=[]);for(let t=this._listeners.iterator(),n=t.next();!n.done;n=t.next()){const t=[];this._asyncDeliveryQueue.push([n.value,e(t,"function"==typeof n.value?n.value:n.value[0]),t])}for(;this._asyncDeliveryQueue.length>0;){const[e,t,s]=this._asyncDeliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){n.onUnexpectedError(e);continue}Object.freeze(s),await Promise.all(s)}}}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return i.toDisposable(s.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}
onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{constructor(){this.buffers=[]}wrapEvent(e){return(t,n,s)=>e(e=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>t.call(n,e)):t.call(n,e)},void 0,s)}bufferEvents(e){const t=[];this.buffers.push(t);const n=e();return this.buffers.pop(),t.forEach(e=>e()),n}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=i.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}
dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}})),define(e[8],t([1,0,3]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s=Object.freeze((function(e,t){const n=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(n)}}}));var i;!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||(t instanceof r||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:s})}(i=t.CancellationToken||(t.CancellationToken={}));class r{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){
return this._isCancelled?s:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new r),this._token}cancel(){this._token?this._token instanceof r&&this._token.cancel():this._token=i.Cancelled}dispose(e=!1){e&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof r&&this._token.dispose():this._token=i.None}}})),define(e[12],t([1,0,8,4,3,2]),(function(e,t,n,s,i,r){"use strict";function o(e){return e&&"function"==typeof e.then}function c(e){const t=new n.CancellationTokenSource,i=e(t.token),r=new Promise((e,n)=>{t.token.onCancellationRequested(()=>{n(s.canceled())}),Promise.resolve(i).then(n=>{t.dispose(),e(n)},e=>{t.dispose(),n(e)})});return new class{cancel(){t.cancel()}
then(e,t){return r.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return r.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),t.isThenable=o,t.createCancelablePromise=c,t.raceCancellation=function(e,t,n){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(n)))])},t.asPromise=function(e){return new Promise((t,n)=>{const s=e();o(s)?s.then(t,n):t(s)})};class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=a;t.Sequencer=class{constructor(){
this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}};class h{constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{this.completionPromise=null,this.doResolve=null;const e=this.task;return this.task=null,e()})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject(s.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=h;t.ThrottledDelayer=class{constructor(e){this.delayer=new h(e),this.throttler=new a}trigger(e,t){
return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function l(e,t){return t?new Promise((n,i)=>{const r=setTimeout(n,e);t.onCancellationRequested(()=>{clearTimeout(r),i(s.canceled())})}):c(t=>l(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}},t.timeout=l,t.disposableTimeout=function(e,t=0){const n=setTimeout(e,t);return r.toDisposable(()=>clearTimeout(n))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let n=0;const s=e.length;return Promise.resolve(null).then((function i(r){null!=r&&t.push(r);const o=n<s?e[n++]():null;return o?o.then(i):Promise.resolve(t)}))},t.first=function(e,t=(e=>!!e),n=null){let s=0;const i=e.length,r=()=>{if(s>=i)return Promise.resolve(n)
;const o=e[s++];return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):r())};return r()};class u{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new i.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,n)=>{this.outstandingPromises.push({factory:e,c:t,e:n}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=u;class d extends u{constructor(){super(1)}}t.Queue=d;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){
const e=new d;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),this.queues.set(t,e)}return this.queues.get(t)}};t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class f{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),
this.timeoutToken=setTimeout(this.timeoutHandler,e)}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=f;t.RunOnceWorker=class extends f{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=t=>{const n=setTimeout(()=>t(e));let s=!1;return{dispose(){s||(s=!0,clearTimeout(n))}}}}else t.runWhenIdle=(e,t)=>{const n=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let s=!1;return{dispose(){s||(s=!0,cancelIdleCallback(n))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()}catch(e){this._error=e}finally{this._didRun=!0}},
this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}getValue(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,n){let s;for(let i=0;i<n;i++)try{return await e()}catch(e){s=e,await l(t)}throw s}})),define(e[10],t([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});let n=!1,s=!1,i=!1,r=!1,o=!1,c=void 0,a="en",h=void 0,l=void 0;const u="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||u){if("object"==typeof process){n="win32"===process.platform,s="darwin"===process.platform,i="linux"===process.platform,c="en",a="en";const e=process.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),n=t.availableLanguages["*"];c=t.locale,a=n||"en",h=t._translationsConfigFile}catch(e){}r=!0}}else l=navigator.userAgent,n=l.indexOf("Windows")>=0,s=l.indexOf("Macintosh")>=0,
i=l.indexOf("Linux")>=0,o=!0,a=c=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let d=0;s?d=1:n?d=3:i&&(d=2),t.isWindows=n,t.isMacintosh=s,t.isLinux=i,t.isNative=r,t.isWeb=o,t.platform=d,t.userAgent=l,t.isRootUser=function(){return r&&!n&&0===process.getuid()},t.language=a,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}}(t.Language||(t.Language={})),t.locale=c,t.translationsConfigFile=h;const f="object"==typeof self?self:"object"==typeof global?global:{};t.globals=f,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals)
;if("function"==typeof t.globals.postMessage&&!t.globals.importScripts){let e=[];t.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeSetImmediateId)for(let n=0,s=e.length;n<s;n++){const s=e[n];if(s.id===t.data.vscodeSetImmediateId)return e.splice(n,1),void s.callback()}});let n=0;return s=>{const i=++n;e.push({id:i,callback:s}),t.globals.postMessage({vscodeSetImmediateId:i},"*")}}if("undefined"!=typeof process&&"function"==typeof process.nextTick)return process.nextTick.bind(process);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=s?2:n?1:3})),define(e[9],t([1,0,10]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s="undefined"==typeof process?{cwd:()=>"/",env:Object.create(null),get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},nextTick:e=>n.setImmediate(e)}:process;t.cwd=s.cwd,t.env=s.env,
t.platform=s.platform,t.nextTick=s.nextTick})),define(e[16],t([1,0,9]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s=65,i=97,r=90,o=122,c=46,a=47,h=92;class l extends Error{constructor(e,t,n){let s;"string"==typeof t&&0===t.indexOf("not ")?(s="must not be",t=t.replace(/^not /,"")):s="must be";const i=-1!==e.indexOf(".")?"property":"argument";let r=`The "${e}" ${i} ${s} of type ${t}`;super(r+=`. Received type ${typeof n}`),this.code="ERR_INVALID_ARG_TYPE"}}function u(e,t){if("string"!=typeof e)throw new l(t,"string",e)}function d(e){return e===a||e===h}function f(e){return e===a}function g(e){return e>=s&&e<=r||e>=i&&e<=o}function p(e,t,n,s){let i,r="",o=0,h=-1,l=0;for(let u=0;u<=e.length;++u){if(u<e.length)i=e.charCodeAt(u);else{if(s(i))break;i=a}if(s(i)){if(h===u-1||1===l);else if(h!==u-1&&2===l){if(r.length<2||2!==o||r.charCodeAt(r.length-1)!==c||r.charCodeAt(r.length-2)!==c){if(r.length>2){const e=r.lastIndexOf(n);-1===e?(r="",
o=0):o=(r=r.slice(0,e)).length-1-r.lastIndexOf(n),h=u,l=0;continue}if(2===r.length||1===r.length){r="",o=0,h=u,l=0;continue}}t&&(r.length>0?r+=`${n}..`:r="..",o=2)}else r.length>0?r+=n+e.slice(h+1,u):r=e.slice(h+1,u),o=u-h-1;h=u,l=0}else i===c&&-1!==l?++l:l=-1}return r}function m(e,t){const n=t.dir||t.root,s=t.base||(t.name||"")+(t.ext||"");return n?n===t.root?n+s:n+e+s:s}t.win32={resolve(...e){let t="",s="",i=!1;for(let r=e.length-1;r>=-1;r--){let o;if(r>=0?o=e[r]:t?void 0!==(o=n.env["="+t]||n.cwd())&&o.slice(0,3).toLowerCase()===t.toLowerCase()+"\\"||(o=t+"\\"):o=n.cwd(),u(o,"path"),0===o.length)continue;const c=o.length;let a=0,h="",l=!1;const f=o.charCodeAt(0);if(c>1)if(d(f))if(l=!0,d(o.charCodeAt(1))){let e=2,t=e;for(;e<c&&!d(o.charCodeAt(e));++e);if(e<c&&e!==t){const n=o.slice(t,e);for(t=e;e<c&&d(o.charCodeAt(e));++e);if(e<c&&e!==t){for(t=e;e<c&&!d(o.charCodeAt(e));++e);e===c?(h="\\\\"+n+"\\"+o.slice(t),a=e):e!==t&&(h="\\\\"+n+"\\"+o.slice(t,e),a=e)}}
}else a=1;else g(f)&&58===o.charCodeAt(1)&&(h=o.slice(0,2),a=2,c>2&&d(o.charCodeAt(2))&&(l=!0,a=3));else d(f)&&(a=1,l=!0);if(!(h.length>0&&t.length>0&&h.toLowerCase()!==t.toLowerCase())&&(0===t.length&&h.length>0&&(t=h),i||(s=o.slice(a)+"\\"+s,i=l),t.length>0&&i))break}return t+(i?"\\":"")+(s=p(s,!i,"\\",d))||"."},normalize(e){u(e,"path");const t=e.length;if(0===t)return".";let n,s=0,i=!1;const r=e.charCodeAt(0);if(t>1)if(d(r))if(i=!0,d(e.charCodeAt(1))){let i=2,r=i;for(;i<t&&!d(e.charCodeAt(i));++i);if(i<t&&i!==r){const o=e.slice(r,i);for(r=i;i<t&&d(e.charCodeAt(i));++i);if(i<t&&i!==r){for(r=i;i<t&&!d(e.charCodeAt(i));++i);if(i===t)return"\\\\"+o+"\\"+e.slice(r)+"\\";i!==r&&(n="\\\\"+o+"\\"+e.slice(r,i),s=i)}}}else s=1;else g(r)&&58===e.charCodeAt(1)&&(n=e.slice(0,2),s=2,t>2&&d(e.charCodeAt(2))&&(i=!0,s=3));else if(d(r))return"\\";let o;return 0!==(o=s<t?p(e.slice(s),!i,"\\",d):"").length||i||(o="."),o.length>0&&d(e.charCodeAt(t-1))&&(o+="\\"),
void 0===n?i?o.length>0?"\\"+o:"\\":o.length>0?o:"":i?o.length>0?n+"\\"+o:n+"\\":o.length>0?n+o:n},isAbsolute(e){u(e,"path");const t=e.length;if(0===t)return!1;const n=e.charCodeAt(0);return!!d(n)||!!(g(n)&&t>2&&58===e.charCodeAt(1)&&d(e.charCodeAt(2)))},join(...e){if(0===e.length)return".";let n,s;for(let t=0;t<e.length;++t){const i=e[t];u(i,"path"),i.length>0&&(void 0===n?n=s=i:n+="\\"+i)}if(void 0===n)return".";let i=!0,r=0;if("string"==typeof s&&d(s.charCodeAt(0))){++r;const e=s.length;e>1&&d(s.charCodeAt(1))&&(++r,e>2&&(d(s.charCodeAt(2))?++r:i=!1))}if(i){for(;r<n.length&&d(n.charCodeAt(r));++r);r>=2&&(n="\\"+n.slice(r))}return t.win32.normalize(n)},relative(e,n){if(u(e,"from"),u(n,"to"),e===n)return"";const s=t.win32.resolve(e),i=t.win32.resolve(n);if(s===i)return"";if((e=s.toLowerCase())===(n=i.toLowerCase()))return"";let r=0;for(;r<e.length&&e.charCodeAt(r)===h;++r);let o=e.length;for(;o-1>r&&e.charCodeAt(o-1)===h;--o);const c=o-r;let a=0;for(;a<n.length&&n.charCodeAt(a)===h;++a);let l=n.length
;for(;l-1>a&&n.charCodeAt(l-1)===h;--l);const d=l-a,f=c<d?c:d;let g=-1,p=0;for(;p<=f;++p){if(p===f){if(d>f){if(n.charCodeAt(a+p)===h)return i.slice(a+p+1);if(2===p)return i.slice(a+p)}c>f&&(e.charCodeAt(r+p)===h?g=p:2===p&&(g=3));break}const t=e.charCodeAt(r+p);if(t!==n.charCodeAt(a+p))break;t===h&&(g=p)}if(p!==f&&-1===g)return i;let m="";for(-1===g&&(g=0),p=r+g+1;p<=o;++p)p!==o&&e.charCodeAt(p)!==h||(0===m.length?m+="..":m+="\\..");return m.length>0?m+i.slice(a+g,l):(a+=g,i.charCodeAt(a)===h&&++a,i.slice(a,l))},toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const n=t.win32.resolve(e);if(n.length>=3)if(n.charCodeAt(0)===h){if(n.charCodeAt(1)===h){const e=n.charCodeAt(2);if(63!==e&&e!==c)return"\\\\?\\UNC\\"+n.slice(2)}}else if(g(n.charCodeAt(0))&&58===n.charCodeAt(1)&&n.charCodeAt(2)===h)return"\\\\?\\"+n;return e},dirname(e){u(e,"path");const t=e.length;if(0===t)return".";let n=-1,s=-1,i=!0,r=0;const o=e.charCodeAt(0);if(t>1)if(d(o)){if(n=r=1,d(e.charCodeAt(1))){let s=2,i=s
;for(;s<t&&!d(e.charCodeAt(s));++s);if(s<t&&s!==i){for(i=s;s<t&&d(e.charCodeAt(s));++s);if(s<t&&s!==i){for(i=s;s<t&&!d(e.charCodeAt(s));++s);if(s===t)return e;s!==i&&(n=r=s+1)}}}}else g(o)&&58===e.charCodeAt(1)&&(n=r=2,t>2&&d(e.charCodeAt(2))&&(n=r=3));else if(d(o))return e;for(let n=t-1;n>=r;--n)if(d(e.charCodeAt(n))){if(!i){s=n;break}}else i=!1;if(-1===s){if(-1===n)return".";s=n}return e.slice(0,s)},basename(e,t){void 0!==t&&u(t,"ext"),u(e,"path");let n,s=0,i=-1,r=!0;if(e.length>=2){g(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(s=2)}if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";let o=t.length-1,c=-1;for(n=e.length-1;n>=s;--n){const a=e.charCodeAt(n);if(d(a)){if(!r){s=n+1;break}}else-1===c&&(r=!1,c=n+1),o>=0&&(a===t.charCodeAt(o)?-1==--o&&(i=n):(o=-1,i=c))}return s===i?i=c:-1===i&&(i=e.length),e.slice(s,i)}for(n=e.length-1;n>=s;--n)if(d(e.charCodeAt(n))){if(!r){s=n+1;break}}else-1===i&&(r=!1,i=n+1);return-1===i?"":e.slice(s,i)},extname(e){u(e,"path")
;let t=0,n=-1,s=0,i=-1,r=!0,o=0;e.length>=2&&58===e.charCodeAt(1)&&g(e.charCodeAt(0))&&(t=s=2);for(let a=e.length-1;a>=t;--a){const t=e.charCodeAt(a);if(d(t)){if(!r){s=a+1;break}}else-1===i&&(r=!1,i=a+1),t===c?-1===n?n=a:1!==o&&(o=1):-1!==n&&(o=-1)}return-1===n||-1===i||0===o||1===o&&n===i-1&&n===s+1?"":e.slice(n,i)},format(e){if(null===e||"object"!=typeof e)throw new l("pathObject","Object",e);return m("\\",e)},parse(e){u(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.length;let s=0,i=e.charCodeAt(0);if(n>1){if(d(i)){if(s=1,d(e.charCodeAt(1))){let t=2,i=t;for(;t<n&&!d(e.charCodeAt(t));++t);if(t<n&&t!==i){for(i=t;t<n&&d(e.charCodeAt(t));++t);if(t<n&&t!==i){for(i=t;t<n&&!d(e.charCodeAt(t));++t);t===n?s=t:t!==i&&(s=t+1)}}}}else if(g(i)&&58===e.charCodeAt(1)){if(s=2,!(n>2))return t.root=t.dir=e,t;if(d(e.charCodeAt(2))){if(3===n)return t.root=t.dir=e,t;s=3}}}else if(d(i))return t.root=t.dir=e,t;s>0&&(t.root=e.slice(0,s));let r=-1,o=s,a=-1,h=!0,l=e.length-1,f=0
;for(;l>=s;--l)if(d(i=e.charCodeAt(l))){if(!h){o=l+1;break}}else-1===a&&(h=!1,a=l+1),i===c?-1===r?r=l:1!==f&&(f=1):-1!==r&&(f=-1);return-1===r||-1===a||0===f||1===f&&r===a-1&&r===o+1?-1!==a&&(t.base=t.name=e.slice(o,a)):(t.name=e.slice(o,r),t.base=e.slice(o,a),t.ext=e.slice(r,a)),t.dir=o>0&&o!==s?e.slice(0,o-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){let t="",s=!1;for(let i=e.length-1;i>=-1&&!s;i--){let r;u(r=i>=0?e[i]:n.cwd(),"path"),0!==r.length&&(t=r+"/"+t,s=r.charCodeAt(0)===a)}return t=p(t,!s,"/",f),s?t.length>0?"/"+t:"/":t.length>0?t:"."},normalize(e){if(u(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===a,n=e.charCodeAt(e.length-1)===a;return 0!==(e=p(e,!t,"/",f)).length||t||(e="."),e.length>0&&n&&(e+="/"),t?"/"+e:e},isAbsolute:e=>(u(e,"path"),e.length>0&&e.charCodeAt(0)===a),join(...e){if(0===e.length)return".";let n;for(let t=0;t<e.length;++t){const e=arguments[t];u(e,"path"),e.length>0&&(void 0===n?n=e:n+="/"+e)}
return void 0===n?".":t.posix.normalize(n)},relative(e,n){if(u(e,"from"),u(n,"to"),e===n)return"";if((e=t.posix.resolve(e))===(n=t.posix.resolve(n)))return"";let s=1;for(;s<e.length&&e.charCodeAt(s)===a;++s);const i=e.length,r=i-s;let o=1;for(;o<n.length&&n.charCodeAt(o)===a;++o);const c=n.length-o,h=r<c?r:c;let l=-1,d=0;for(;d<=h;++d){if(d===h){if(c>h){if(n.charCodeAt(o+d)===a)return n.slice(o+d+1);if(0===d)return n.slice(o+d)}else r>h&&(e.charCodeAt(s+d)===a?l=d:0===d&&(l=0));break}const t=e.charCodeAt(s+d);if(t!==n.charCodeAt(o+d))break;t===a&&(l=d)}let f="";for(d=s+l+1;d<=i;++d)d!==i&&e.charCodeAt(d)!==a||(0===f.length?f+="..":f+="/..");return f.length>0?f+n.slice(o+l):(o+=l,n.charCodeAt(o)===a&&++o,n.slice(o))},toNamespacedPath:e=>e,dirname(e){if(u(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===a;let n=-1,s=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===a){if(!s){n=t;break}}else s=!1;return-1===n?t?"/":".":t&&1===n?"//":e.slice(0,n)},basename(e,t){void 0!==t&&u(t,"ext"),u(e,"path")
;let n,s=0,i=-1,r=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";let o=t.length-1,c=-1;for(n=e.length-1;n>=0;--n){const h=e.charCodeAt(n);if(h===a){if(!r){s=n+1;break}}else-1===c&&(r=!1,c=n+1),o>=0&&(h===t.charCodeAt(o)?-1==--o&&(i=n):(o=-1,i=c))}return s===i?i=c:-1===i&&(i=e.length),e.slice(s,i)}for(n=e.length-1;n>=0;--n)if(e.charCodeAt(n)===a){if(!r){s=n+1;break}}else-1===i&&(r=!1,i=n+1);return-1===i?"":e.slice(s,i)},extname(e){u(e,"path");let t=-1,n=0,s=-1,i=!0,r=0;for(let o=e.length-1;o>=0;--o){const h=e.charCodeAt(o);if(h!==a)-1===s&&(i=!1,s=o+1),h===c?-1===t?t=o:1!==r&&(r=1):-1!==t&&(r=-1);else if(!i){n=o+1;break}}return-1===t||-1===s||0===r||1===r&&t===s-1&&t===n+1?"":e.slice(t,s)},format(e){if(null===e||"object"!=typeof e)throw new l("pathObject","Object",e);return m("/",e)},parse(e){u(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.charCodeAt(0)===a;let s;n?(t.root="/",s=1):s=0
;let i=-1,r=0,o=-1,h=!0,l=e.length-1,d=0;for(;l>=s;--l){const t=e.charCodeAt(l);if(t!==a)-1===o&&(h=!1,o=l+1),t===c?-1===i?i=l:1!==d&&(d=1):-1!==i&&(d=-1);else if(!h){r=l+1;break}}return-1===i||-1===o||0===d||1===d&&i===o-1&&i===r+1?-1!==o&&(t.base=t.name=0===r&&n?e.slice(1,o):e.slice(r,o)):(0===r&&n?(t.name=e.slice(1,i),t.base=e.slice(1,o)):(t.name=e.slice(r,i),t.base=e.slice(r,o)),t.ext=e.slice(i,o)),r>0?t.dir=e.slice(0,r-1):n&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===n.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===n.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===n.platform?t.win32.join:t.posix.join,t.resolve="win32"===n.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===n.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===n.platform?t.win32.dirname:t.posix.dirname,t.basename="win32"===n.platform?t.win32.basename:t.posix.basename,
t.extname="win32"===n.platform?t.win32.extname:t.posix.extname,t.format="win32"===n.platform?t.win32.format:t.posix.format,t.parse="win32"===n.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===n.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===n.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===n.platform?t.win32.delimiter:t.posix.delimiter})),define(e[13],t([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length},t.pad=function(e,t,n="0"){const s=""+e,i=[s];for(let e=s.length;e<t;e++)i.push(n);return i.reverse().join("")};const n=/{(\d+)}/g;function s(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function i(e,t){if(!e||!t)return e;const n=t.length;if(0===n||0===e.length)return e;let s=0;for(;e.indexOf(t,s)===s;)s+=n;return e.substring(s)}function r(e,t){if(!e||!t)return e;const n=t.length,s=e.length;if(0===n||0===s)return e;let i=s,r=-1
;for(;-1!==(r=e.lastIndexOf(t,i-1))&&r+n===i;){if(0===r)return"";i=r}return e.substring(0,i)}function o(e,t){return e<t?-1:e>t?1:0}function c(e){return e>=97&&e<=122}function a(e){return e>=65&&e<=90}function h(e){return c(e)||a(e)}function l(e,t,n=e.length){for(let s=0;s<n;s++){const n=e.charCodeAt(s),i=t.charCodeAt(s);if(n!==i)if(h(n)&&h(i)){const e=Math.abs(n-i);if(0!==e&&32!==e)return!1}else if(String.fromCharCode(n).toLowerCase()!==String.fromCharCode(i).toLowerCase())return!1}return!0}function u(e,t,n,s,i,r){for(;t<n&&i<r;){if(e[t]!==s[i])return!1;t+=1,i+=1}return!0}function d(e){return 55296<=e&&e<=56319}function f(e){return 56320<=e&&e<=57343}function g(e,t,n){const s=e.charCodeAt(n);if(d(s)&&n+1<t){const t=e.charCodeAt(n+1);if(f(t))return t-56320+(s-55296<<10)+65536}return s}function p(e,t){const n=e.charCodeAt(t-1);if(f(n)&&t>1){const s=e.charCodeAt(t-2);if(d(s))return n-56320+(s-55296<<10)+65536}return n}function m(e,t){const n=e.length,s=t,i=g(e,n,t);for(t+=i>=65536?2:1;t<n;){const s=g(e,n,t)
;if(!_(s))break;t+=s>=65536?2:1}const r=t;t=s;let o=i;for(;t>0&&_(o);)t-=(o=p(e,t))>=65536?2:1;return[t,r]}function _(e){return v.getInstance().isUnicodeMark(e)}t.format=function(e,...t){return 0===t.length?e:e.replace(n,(function(e,n){const s=parseInt(n,10);return isNaN(s)||s<0||s>=t.length?e:t[s]}))},t.escape=function(e){return e.replace(/[<>&]/g,(function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}}))},t.escapeRegExpCharacters=s,t.trim=function(e,t=" "){return r(i(e,t),t)},t.ltrim=i,t.rtrim=r,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.startsWith=function(e,t){if(e.length<t.length)return!1;if(e===t)return!0;for(let n=0;n<t.length;n++)if(e[n]!==t[n])return!1;return!0},t.endsWith=function(e,t){const n=e.length-t.length;return n>0?e.indexOf(t,n)===n:0===n&&e===t},t.createRegExp=function(e,t,n={}){
if(!e)throw new Error("Cannot create regex from empty string");t||(e=s(e)),n.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let i="";return n.global&&(i+="g"),n.matchCase||(i+="i"),n.multiline&&(i+="m"),n.unicode&&(i+="u"),new RegExp(e,i)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(let t=0,n=e.length;t<n;t++){const n=e.charCodeAt(t);if(32!==n&&9!==n)return t}return-1},t.getLeadingWhitespace=function(e,t=0,n=e.length){for(let s=t;s<n;s++){const n=e.charCodeAt(s);if(32!==n&&9!==n)return e.substring(t,s)}return e.substring(t,n)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){for(let n=t;n>=0;n--){const t=e.charCodeAt(n)
;if(32!==t&&9!==t)return n}return-1},t.compare=o,t.compareIgnoreCase=function(e,t){const n=Math.min(e.length,t.length);for(let s=0;s<n;s++){let n=e.charCodeAt(s),i=t.charCodeAt(s);if(n===i)continue;a(n)&&(n+=32),a(i)&&(i+=32);const r=n-i;if(0!==r)return c(n)&&c(i)?r:o(e.toLowerCase(),t.toLowerCase())}return e.length<t.length?-1:e.length>t.length?1:0},t.isLowerAsciiLetter=c,t.isUpperAsciiLetter=a,t.equalsIgnoreCase=function(e,t){return e.length===t.length&&l(e,t)},t.startsWithIgnoreCase=function(e,t){const n=t.length;return!(t.length>e.length)&&l(e,t,n)},t.commonPrefixLength=function(e,t){let n,s=Math.min(e.length,t.length);for(n=0;n<s;n++)if(e.charCodeAt(n)!==t.charCodeAt(n))return n;return s},t.commonSuffixLength=function(e,t){let n,s=Math.min(e.length,t.length);const i=e.length-1,r=t.length-1;for(n=0;n<s;n++)if(e.charCodeAt(i-n)!==t.charCodeAt(r-n))return n;return s},t.overlap=function(e,t){const n=e.length;let s=t.length,i=n-s;if(0===i)return e===t?n:0;for(i<0&&(s+=i,i=0);i<n&&s>0;){
if(u(e,i,n,t,0,s))return s;s-=1,i+=1}return 0},t.isHighSurrogate=d,t.isLowSurrogate=f,t.getNextCodePoint=g,t.nextCharLength=function(e,t){const n=t,s=e.length;let i=g(e,s,t);for(t+=i>=65536?2:1;t<s&&_(i=g(e,s,t));)t+=i>=65536?2:1;return t-n},t.prevCharLength=function(e,t){const n=t;let s=p(e,t);for(t-=s>=65536?2:1;t>0&&_(s);)t-=(s=p(e,t))>=65536?2:1;return n-t},t.getCharContainingOffset=function(e,t){return t>0&&f(e.charCodeAt(t))?m(e,t-1):m(e,t)},t.isUnicodeMark=_;class v{constructor(){
const e=[768,879,1155,1161,1425,1469,1471,1471,1473,1474,1476,1477,1479,1479,1552,1562,1611,1631,1648,1648,1750,1756,1759,1764,1767,1768,1770,1773,1809,1809,1840,1866,1958,1968,2027,2035,2045,2045,2070,2073,2075,2083,2085,2087,2089,2093,2137,2139,2259,2273,2275,2307,2362,2364,2366,2383,2385,2391,2402,2403,2433,2435,2492,2492,2494,2509,2519,2519,2530,2531,2558,2563,2620,2641,2672,2673,2677,2677,2689,2691,2748,2748,2750,2765,2786,2787,2810,2819,2876,2876,2878,2903,2914,2915,2946,2946,3006,3021,3031,3031,3072,3076,3134,3158,3170,3171,3201,3203,3260,3260,3262,3286,3298,3299,3328,3331,3387,3388,3390,3405,3415,3415,3426,3427,3457,3459,3530,3551,3570,3571,3633,3633,3636,3642,3655,3662,3761,3761,3764,3772,3784,3789,3864,3865,3893,3893,3895,3895,3897,3897,3902,3903,3953,3972,3974,3975,3981,4028,4038,4038,4139,4158,4182,4185,4190,4192,4194,4196,4199,4205,4209,4212,4226,4237,4239,4239,4250,4253,4957,4959,5906,5908,5938,5940,5970,5971,6002,6003,6068,6099,6109,6109,6155,6157,6277,6278,6313,6313,6432,6459,6679,6683,6741,6783,6832,6916,6964,6980,7019,7027,7040,7042,7073,7085,7142,7155,7204,7223,7376,7378,7380,7400,7405,7405,7412,7412,7415,7417,7616,7679,8400,8432,11503,11505,11647,11647,11744,11775,12330,12335,12441,12442,42607,42610,42612,42621,42654,42655,42736,42737,43010,43010,43014,43014,43019,43019,43043,43047,43052,43052,43136,43137,43188,43205,43232,43249,43263,43263,43302,43309,43335,43347,43392,43395,43443,43456,43493,43493,43561,43574,43587,43587,43596,43597,43643,43645,43696,43696,43698,43700,43703,43704,43710,43711,43713,43713,43755,43759,43765,43766,44003,44010,44012,44013,64286,64286,65024,65039,65056,65071,66045,66045,66272,66272,66422,66426,68097,68111,68152,68159,68325,68326,68900,68903,69291,69292,69446,69456,69632,69634,69688,69702,69759,69762,69808,69818,69888,69890,69927,69940,69957,69958,70003,70003,70016,70018,70067,70080,70089,70092,70094,70095,70188,70199,70206,70206,70367,70378,70400,70403,70459,70460,70462,70477,70487,70487,70498,70516,70709,70726,70750,70750,70832,70851,71087,71104,71132,71133,71216,71232,71339,71351,71453,71467,71724,71738,71984,71998,72e3,72e3,72002,72003,72145,72160,72164,72164,72193,72202,72243,72249,72251,72254,72263,72263,72273,72283,72330,72345,72751,72767,72850,72886,73009,73029,73031,73031,73098,73111,73459,73462,92912,92916,92976,92982,94031,94031,94033,94098,94180,94193,113821,113822,119141,119145,119149,119154,119163,119170,119173,119179,119210,119213,119362,119364,121344,121398,121403,121452,121461,121461,121476,121476,121499,122922,123184,123190,123628,123631,125136,125142,125252,125258,917760,917999],t=e[e.length-1],n=Math.ceil(t/8),s=new Uint8Array(n)
;for(let t=0,n=e.length/2;t<n;t++){const n=e[2*t+1];for(let i=e[2*t];i<=n;i++){const e=i>>>3,t=7&i;s[e]=s[e]|1<<t}}this.arr=s}static getInstance(){return v._INSTANCE||(v._INSTANCE=new v),v._INSTANCE}isUnicodeMark(e){const t=e>>>3,n=7&e;return!(t>=this.arr.length)&&!!(this.arr[t]&1<<n)}}v._INSTANCE=null,t.encodeUTF8=function(e){const t=e.length;let n=0,s=0;for(;s<t;){const i=g(e,t,s);s+=i>=65536?2:1,n+=i<128?1:i<2048?2:i<65536?3:4}const i=new Uint8Array(n);s=0;let r=0;for(;s<t;){const n=g(e,t,s);s+=n>=65536?2:1,n<128?i[r++]=n:n<2048?(i[r++]=192|(1984&n)>>>6,i[r++]=128|(63&n)>>>0):n<65536?(i[r++]=224|(61440&n)>>>12,i[r++]=128|(4032&n)>>>6,i[r++]=128|(63&n)>>>0):(i[r++]=240|(1835008&n)>>>18,i[r++]=128|(258048&n)>>>12,i[r++]=128|(4032&n)>>>6,i[r++]=128|(63&n)>>>0)}return i},t.decodeUTF8=function(e){const t=e.byteLength,n=[];let s=0;for(;s<t;){const i=e[s];let r
;if((r=i>=240&&s+3<t?(7&e[s++])<<18>>>0|(63&e[s++])<<12>>>0|(63&e[s++])<<6>>>0|(63&e[s++])<<0>>>0:i>=224&&s+2<t?(15&e[s++])<<12>>>0|(63&e[s++])<<6>>>0|(63&e[s++])<<0>>>0:i>=192&&s+1<t?(31&e[s++])<<6>>>0|(63&e[s++])<<0>>>0:e[s++])>=0&&r<=55295||r>=57344&&r<=65535)n.push(String.fromCharCode(r));else if(r>=65536&&r<=1114111){const e=r-65536,t=55296+((1047552&e)>>>10),s=56320+((1023&e)>>>0);n.push(String.fromCharCode(t)),n.push(String.fromCharCode(s))}else n.push(String.fromCharCode(65533))}return n.join("")};const w=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/
;t.containsRTL=function(e){return w.test(e)};const C=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;t.containsEmoji=function(e){return C.test(e)};const k=/^[\t\n\r\x20-\x7E]*$/;function b(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}t.isBasicASCII=function(e){return k.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,n=e.length;t<n;t++)if(b(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=b,t.isEmojiImprecise=function(e){return e>=127462&&e<=127487||e>=9728&&e<=10175||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129003||e>=129280&&e<=129535||e>=129648&&e<=129651||e>=129656&&e<=129666||e>=129680&&e<=129685},t.lcut=function(e,t){if(e.length<t)return e;const n=/\b/g;let s=0;for(;n.test(e)&&!(e.length-n.lastIndex<t);)s=n.lastIndex,n.lastIndex+=1;return e.substring(s).replace(/^\s/,"")}
;const y=/\x1B\x5B[12]?K/g,A=/\x1b\[\d+m/g,E=/\x1b\[0?m/g;function x(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(y,"")).replace(A,"")).replace(E,"")),e},t.removeAccents=function(){if("function"!=typeof String.prototype.normalize)return function(e){return e};{const e=/[\u0300-\u036f]/g;return function(t){return t.normalize("NFD").replace(e,"")}}}(),t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=x,t.stripUTF8BOM=function(e){return x(e)?e.substr(1):e},t.safeBtoa=function(e){return btoa(encodeURIComponent(e))},t.repeat=function(e,t){let n="";for(let s=0;s<t;s++)n+=e;return n},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const n=t.length,s=e.toLowerCase();let i=0,r=-1;for(;i<n;){const e=s.indexOf(t[i],r+1);if(e<0)return!1;r=e,i++}return!0},t.containsUppercaseCharacter=function(e,t=!1){return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){
return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let n=-1;do{n=e.indexOf("\n",n+1),t--}while(t>0&&n>=0);return n>=0?e.substr(0,n):e},t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)}})),define(e[5],t([1,0,13]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const s="undefined"!=typeof Buffer,i="undefined"!=typeof TextEncoder,r="undefined"!=typeof TextDecoder;let o,c;class a{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return new a(s?Buffer.allocUnsafe(e):new Uint8Array(e))}static wrap(e){return s&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new a(e)}static fromString(e){return s?new a(Buffer.from(e)):i?(o||(o=new TextEncoder),new a(o.encode(e))):new a(n.encodeUTF8(e))}static concat(e,t){if(void 0===t){t=0;for(let n=0,s=e.length;n<s;n++)t+=e[n].byteLength}const n=a.alloc(t);let s=0;for(let t=0,i=e.length;t<i;t++){
const i=e[t];n.set(i,s),s+=i.byteLength}return n}toString(){return s?this.buffer.toString():r?(c||(c=new TextDecoder),c.decode(this.buffer)):n.decodeUTF8(this.buffer)}slice(e,t){return new a(this.buffer.subarray(e,t))}set(e,t){this.buffer.set(e.buffer,t)}readUInt32BE(e){return h(this.buffer,e)}writeUInt32BE(e,t){l(this.buffer,e,t)}readUInt8(e){return function(e,t){return e[t]}(this.buffer,e)}writeUInt8(e,t){!function(e,t,n){e[n]=t}(this.buffer,e,t)}}function h(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function l(e,t,n){e[n+3]=t,t>>>=8,e[n+2]=t,t>>>=8,e[n+1]=t,t>>>=8,e[n]=t}function u(){return new d}t.VSBuffer=a,t.readUInt32BE=h,t.writeUInt32BE=l,t.isVSBufferReadableStream=function(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)},t.readableToBuffer=function(e){const t=[];let n;for(;n=e.read();)t.push(n);return a.concat(t)},t.bufferToReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},t.streamToBuffer=function(e){return new Promise((t,n)=>{
const s=[];e.on("data",e=>s.push(e)),e.on("error",e=>n(e)),e.on("end",()=>t(a.concat(s)))})},t.bufferToStream=function(e){const t=u();return t.end(e),t},t.toVSBufferReadableStream=function(e){const t=u();return e.on("data",e=>t.write("string"==typeof e?a.fromString(e):a.wrap(e))),e.on("end",()=>t.end()),e.on("error",e=>t.error(e)),t},t.writeableBufferStream=u;class d{constructor(){this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]}}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){this.state.destroyed||(this.state.flowing?this.listeners.data.forEach(t=>t(e)):this.buffer.data.push(e))}error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),
this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}flowData(){if(this.buffer.data.length>0){const e=a.concat(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0)}}})),define(e[15],t([1,0]),(function(e,t){
"use strict";Object.defineProperty(t,"__esModule",{value:!0});class n{constructor(e){this._value=e}asHex(){return this._value}}class s extends n{constructor(){super([s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),"-",s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),"-","4",s._randomHex(),s._randomHex(),s._randomHex(),"-",s._oneOf(s._timeHighBits),s._randomHex(),s._randomHex(),s._randomHex(),"-",s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex(),s._randomHex()].join(""))}static _oneOf(e){return e[Math.floor(e.length*Math.random())]}static _randomHex(){return s._oneOf(s._chars)}}function i(){return new s}s._chars=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"],s._timeHighBits=["8","9","a","b"],t.v4=i;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function o(e){
return r.test(e)}t.isUUID=o,t.parse=function(e){if(!o(e))throw new Error("invalid uuid");return new n(e)},t.generateUuid=function(){return i().asHex()}})),define(e[7],t([1,0,3,2,12,8,4,5]),(function(e,t,n,s,i,r,o,c){"use strict";var a,h;Object.defineProperty(t,"__esModule",{value:!0}),function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(a||(a={}));class l{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class u{constructor(){this.buffers=[]}get buffer(){return c.VSBuffer.concat(this.buffers)}write(e){
this.buffers.push(e)}}function d(e){const t=c.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function f(e){return e.read(4).readUInt32BE(0)}function g(e){const t=c.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",e[e.Array=4]="Array",e[e.Object=5]="Object"}(h||(h={}));const p={Undefined:g(h.Undefined),String:g(h.String),Buffer:g(h.Buffer),VSBuffer:g(h.VSBuffer),Array:g(h.Array),Object:g(h.Object)},m="undefined"!=typeof Buffer;function _(e,t){if(void 0===t)e.write(p.Undefined);else if("string"==typeof t){const n=c.VSBuffer.fromString(t);e.write(p.String),e.write(d(n.byteLength)),e.write(n)}else if(m&&Buffer.isBuffer(t)){const n=c.VSBuffer.wrap(t);e.write(p.Buffer),e.write(d(n.byteLength)),e.write(n)}else if(t instanceof c.VSBuffer)e.write(p.VSBuffer),e.write(d(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(p.Array),e.write(d(t.length));for(const n of t)_(e,n)}else{
const n=c.VSBuffer.fromString(JSON.stringify(t));e.write(p.Object),e.write(d(n.byteLength)),e.write(n)}}function v(e){switch(e.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return e.read(f(e)).toString();case h.Buffer:return e.read(f(e)).buffer;case h.VSBuffer:return e.read(f(e));case h.Array:{const t=f(e),n=[];for(let s=0;s<t;s++)n.push(v(e));return n}case h.Object:return JSON.parse(e.read(f(e)).toString())}}class w{constructor(e,t,n=1e3){this.protocol=e,this.ctx=t,this.timeoutDelay=n,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),setTimeout(()=>this.flushPendingRequests(e),0)}sendResponse(e){switch(e.type){case 200:return this.send([e.type]);case 201:case 202:case 204:case 203:return this.send([e.type,e.id],e.data)}}send(e,t){const n=new u;_(n,e),_(n,t),this.sendBuffer(n.buffer)}sendBuffer(e){try{this.protocol.send(e)
}catch(e){}}onRawMessage(e){const t=new l(e),n=v(t),s=v(t),i=n[0];switch(i){case 100:return this.onPromise({type:i,id:n[1],channelName:n[2],name:n[3],arg:s});case 102:return this.onEventListen({type:i,id:n[1],channelName:n[2],name:n[3],arg:s});case 101:case 103:return this.disposeActiveRequest({type:i,id:n[1]})}}onPromise(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const n=new r.CancellationTokenSource;let i;try{i=t.call(this.ctx,e.name,e.arg,n.token)}catch(e){i=Promise.reject(e)}const o=e.id;i.then(t=>{this.sendResponse({id:o,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:o,data:{message:t.message,name:t.name,stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:o,data:t,type:203}),this.activeRequests.delete(e.id)});const c=s.toDisposable(()=>n.cancel());this.activeRequests.set(e.id,c)}onEventListen(e){const t=this.channels.get(e.channelName)
;if(!t)return void this.collectPendingRequest(e);const n=e.id,s=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:n,data:e,type:204}));this.activeRequests.set(e.id,s)}disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const n=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:n})}flushPendingRequests(e){const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){
this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=w;class C{constructor(e){this.protocol=e,this.state=a.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new n.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e))}getChannel(e){const t=this;return{call:(n,s,i)=>t.requestPromise(e,n,s,i),listen:(n,s)=>t.requestEvent(e,n,s)}}requestPromise(e,t,n,c=r.CancellationToken.None){const a=this.lastRequestId++,h={id:a,type:100,channelName:e,name:t,arg:n};if(c.isCancellationRequested)return Promise.reject(o.canceled());let l;return new Promise((e,t)=>{if(c.isCancellationRequested)return t(o.canceled());let n=i.createCancelablePromise(e=>this.whenInitialized());n.then(()=>{n=null;this.handlers.set(a,n=>{switch(n.type){case 201:this.handlers.delete(a),e(n.data);break;case 202:
this.handlers.delete(a);const s=new Error(n.data.message);s.stack=n.data.stack,s.name=n.data.name,t(s);break;case 203:this.handlers.delete(a),t(n.data)}}),this.sendRequest(h)});const r=()=>{n?(n.cancel(),n=null):this.sendRequest({id:a,type:101}),t(o.canceled())},u=c.onCancellationRequested(r);l=s.combinedDisposable(s.toDisposable(r),u),this.activeRequests.add(l)}).finally(()=>this.activeRequests.delete(l))}requestEvent(e,t,s){const r=this.lastRequestId++,o={id:r,type:102,channelName:e,name:t,arg:s};let c=null;const a=new n.Emitter({onFirstListenerAdd:()=>{(c=i.createCancelablePromise(e=>this.whenInitialized())).then(()=>{c=null,this.activeRequests.add(a),this.sendRequest(o)})},onLastListenerRemove:()=>{c?(c.cancel(),c=null):(this.activeRequests.delete(a),this.sendRequest({id:r,type:103}))}});return this.handlers.set(r,e=>a.fire(e.data)),a.event}sendRequest(e){switch(e.type){case 100:case 102:return this.send([e.type,e.id,e.channelName,e.name],e.arg);case 101:case 103:return this.send([e.type,e.id])}}
send(e,t){const n=new u;_(n,e),_(n,t),this.sendBuffer(n.buffer)}sendBuffer(e){try{this.protocol.send(e)}catch(e){}}onBuffer(e){const t=new l(e),n=v(t),s=v(t);switch(n[0]){case 200:return this.onResponse({type:n[0]});case 201:case 202:case 204:case 203:return this.onResponse({type:n[0],id:n[1],data:s})}}onResponse(e){if(200===e.type)return this.state=a.Idle,void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===a.Idle?Promise.resolve():n.Event.toPromise(this.onDidInitialize)}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=C;t.IPCServer=class{constructor(e){this.channels=new Map,this._connections=new Set,this._onDidChangeConnections=new n.Emitter,this.onDidChangeConnections=this._onDidChangeConnections.event,e(({protocol:e,onDidClientDisconnect:t})=>{n.Event.once(e.onMessage)(n=>{const s=v(new l(n)),i=new w(e,s),r=new C(e)
;this.channels.forEach((e,t)=>i.registerChannel(t,e));const o={channelServer:i,channelClient:r,ctx:s};this._connections.add(o),this._onDidChangeConnections.fire(o),t(()=>{i.dispose(),r.dispose(),this._connections.delete(o)})})})}get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const n=this;return{call:(s,i,r)=>k(t.routeCall(n,s,i).then(t=>t.channelClient.getChannel(e))).call(s,i,r),listen:(s,i)=>k(t.routeEvent(n,s,i).then(t=>t.channelClient.getChannel(e))).listen(s,i)}}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(n=>{n.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidChangeConnections.dispose()}};function k(e){return{call:(t,n,s)=>e.then(e=>e.call(t,n,s)),listen(t,s){const i=new n.Relay;return e.then(e=>i.input=e.listen(t,s)),i.event}}}t.IPCClient=class{constructor(e,t){const n=new u;_(n,t),e.send(n.buffer),this.channelClient=new C(e),this.channelServer=new w(e,t)}getChannel(e){
return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=k,t.getNextTickChannel=function(e){let t=!1;return{call:(n,s,r)=>t?e.call(n,s,r):i.timeout(0).then(()=>t=!0).then(()=>e.call(n,s,r)),listen(s,r){if(t)return e.listen(s,r);const o=new n.Relay;return i.timeout(0).then(()=>t=!0).then(()=>o.input=e.listen(s,r)),o.event}}};t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t);return await n.Event.toPromise(e.onDidChangeConnections),await this.route(e)}}})),define(e[17],t([1,0,3,7,2,5,10,9]),(function(e,t,n,s,i,r,o,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0});let a=null;function h(){return a||(a=r.VSBuffer.alloc(0)),a}class l{constructor(){this._chunks=[],this._totalLength=0}
get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return h();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const n=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),n}if(this._chunks[0].byteLength>e){const n=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),n}let n=r.VSBuffer.alloc(e),s=0,i=0;for(;e>0;){const r=this._chunks[i];if(r.byteLength>e){const o=r.slice(0,e);n.set(o,s),s+=e,t&&(this._chunks[i]=r.slice(e),this._totalLength-=e),e-=e}else n.set(r,s),s+=r.byteLength,t?(this._chunks.shift(),this._totalLength-=r.byteLength):i++,e-=r.byteLength}return n}}var u;t.ChunkStream=l,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect"
}(u||(u={})),function(e){e[e.HeaderLength=13]="HeaderLength",e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",e[e.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class d{constructor(e,t,n,s){this.type=e,this.id=t,this.ack=n,this.data=s,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends i.Disposable{constructor(e){super(),this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new l,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),
this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,n=this._state.id,s=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,n,s,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){this.flush(),this._isDisposed=!0}flush(){this._writeNow()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=r.VSBuffer.alloc(13)
;t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){const n=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,n}_bufferTake(){const e=r.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&o.setImmediate(()=>{this._writeNow()})}_writeNow(){0!==this._totalLength&&this._socket.write(this._bufferTake())}}class p extends i.Disposable{constructor(e){super(),this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onClose=new n.Emitter,this.onClose=this._onClose.event,this._socket=e,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onClose.fire()))}getSocket(){return this._socket}
sendDisconnect(){}send(e){this._socketWriter.write(new d(1,0,0,e))}}t.Protocol=p;class m extends s.IPCClient{constructor(e,t){super(e,t),this.protocol=e}static fromSocket(e,t){return new m(new p(e),t)}get onClose(){return this.protocol.onClose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=m;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,c.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){
this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=_;class v{constructor(e){this.data=e,this.next=null}}class w{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,n=this._first;for(;n;)e[t++]=n.data,n=n.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new v(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}t.PersistentProtocol=class{constructor(e,t=null){this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onClose=new _,this.onClose=this._onClose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,
this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new w,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._socketDisposables=[],this._socket=e,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),
this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=i.dispose(this._socketDisposables)}sendDisconnect(){const e=new d(5,0,0,h());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new d(4,0,0,h());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=2e4?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{
this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},2e4-e+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=i.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._socket=e,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray();for(let t=0,n=e.length;t<n;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onClose.fire()}
_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}1===e.type?e.id>this._incomingMsgId&&(e.id!==this._incomingMsgId+1&&console.error(`PROTOCOL CORRUPTION, LAST SAW MSG ${this._incomingMsgId} AND HAVE NOW RECEIVED MSG ${e.id}`),this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)):2===e.type?this._onControlMessage.fire(e.data):5===e.type&&this._onClose.fire()}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new d(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(e){const t=new d(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return
;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=2e4?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},2e4-t+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new d(3,0,this._incomingAckId,h());this._socketWriter.write(e)}}})),define(e[18],t([1,0,19,3,7,16,20,15,2,5,17]),(function(e,t,n,s,i,r,o,c,a,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class u{constructor(e){this.socket=e}dispose(){this.socket.destroy()}onData(e){const t=t=>e(h.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}
onClose(e){return this.socket.on("close",e),{dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){this.socket.destroyed||this.socket.write(e.buffer)}end(){this.socket.end()}}var d,f;t.NodeSocket=u,function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(d||(d={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",e[e.Fin=4]="Fin"}(f||(f={}));class g extends a.Disposable{constructor(e){super(),this._onData=this._register(new s.Emitter),this._state={state:1,readLen:2,mask:0},this.socket=e,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e)))}dispose(){this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this.socket.onClose(e)}onEnd(e){return this.socket.onEnd(e)}write(e){let t=2;e.byteLength<126?t+=0:e.byteLength<65536?t+=2:t+=8;const n=h.VSBuffer.alloc(t);if(n.writeUInt8(130,0),
e.byteLength<126)n.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){n.writeUInt8(126,1);let t=1;n.writeUInt8(e.byteLength>>>8&255,++t),n.writeUInt8(e.byteLength>>>0&255,++t)}else{n.writeUInt8(127,1);let t=1;n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(e.byteLength>>>24&255,++t),n.writeUInt8(e.byteLength>>>16&255,++t),n.writeUInt8(e.byteLength>>>8&255,++t),n.writeUInt8(e.byteLength>>>0&255,++t)}this.socket.write(h.VSBuffer.concat([n,e]))}end(){this.socket.end()}_acceptChunk(e){if(0!==e.byteLength)for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen).readUInt8(1),t=(128&e)>>>7,n=127&e;this._state.state=2,this._state.readLen=2+(t?4:0)+(126===n?2:0)+(127===n?8:0),this._state.mask=0}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),n=(128&t)>>>7;let s=127&t,i=1
;126===s?s=256*e.readUInt8(++i)+e.readUInt8(++i):127===s&&(s=0*e.readUInt8(++i)+0*e.readUInt8(++i)+0*e.readUInt8(++i)+0*e.readUInt8(++i)+e.readUInt8(++i)*2**24+65536*e.readUInt8(++i)+256*e.readUInt8(++i)+e.readUInt8(++i));let r=0;n&&(r=e.readUInt8(++i)*2**24+65536*e.readUInt8(++i)+256*e.readUInt8(++i)+e.readUInt8(++i)),this._state.state=3,this._state.readLen=s,this._state.mask=r}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);p(e,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._onData.fire(e)}}}function p(e,t){if(0===t)return;let n=e.byteLength>>>2;for(let s=0;s<n;s++){const n=e.readUInt32BE(4*s);e.writeUInt32BE(n^t,4*s)}let s=4*n,i=e.byteLength-s;const r=t>>>24&255,o=t>>>16&255,c=t>>>8&255;i>=1&&e.writeUInt8(e.readUInt8(s)^r,s),i>=2&&e.writeUInt8(e.readUInt8(s+1)^o,s+1),i>=3&&e.writeUInt8(e.readUInt8(s+2)^c,s+2)}t.WebSocketNodeSocket=g,t.generateRandomPipeName=function(){const e=c.generateUuid()
;return"win32"===process.platform?`\\\\.\\pipe\\vscode-ipc-${e}-sock`:r.join(o.tmpdir(),`vscode-ipc-${e}.sock`)};class m extends i.IPCServer{constructor(e){super(m.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){const t=s.Event.fromNodeEventEmitter(e,"connection");return s.Event.map(t,e=>({protocol:new l.Protocol(new u(e)),onDidClientDisconnect:s.Event.once(s.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=m,t.serve=function(e){return new Promise((t,s)=>{const i=n.createServer();i.on("error",s),i.listen(e,()=>{i.removeListener("error",s),t(new m(i))})})},t.connect=function(e,t){return new Promise((s,i)=>{const r=n.createConnection(e,()=>{r.removeListener("error",i),s(l.Client.fromSocket(new u(r),t))});r.once("error",i)})}})),define(e[21],t([1,0,18]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.DriverChannel=class{constructor(e){this.driver=e}listen(e,t){
throw new Error("No event found")}call(e,t,n){switch(t){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(n);case"reloadWindow":return this.driver.reloadWindow(n);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(n[0],n[1]);case"click":return this.driver.click(n[0],n[1],n[2],n[3]);case"doubleClick":return this.driver.doubleClick(n[0],n[1]);case"setValue":return this.driver.setValue(n[0],n[1],n[2]);case"getTitle":return this.driver.getTitle(n[0]);case"isActiveElement":return this.driver.isActiveElement(n[0],n[1]);case"getElements":return this.driver.getElements(n[0],n[1],n[2]);case"getElementXY":return this.driver.getElementXY(n[0],n[1],n[2]);case"typeInEditor":return this.driver.typeInEditor(n[0],n[1],n[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(n[0],n[1]);case"writeInTerminal":return this.driver.writeInTerminal(n[0],n[1],n[2])}
throw new Error(`Call not found: ${t}`)}};class s{constructor(e){this.channel=e}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(e){return this.channel.call("capturePage",e)}reloadWindow(e){return this.channel.call("reloadWindow",e)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(e,t){return this.channel.call("dispatchKeybinding",[e,t])}click(e,t,n,s){return this.channel.call("click",[e,t,n,s])}doubleClick(e,t){return this.channel.call("doubleClick",[e,t])}setValue(e,t,n){return this.channel.call("setValue",[e,t,n])}getTitle(e){return this.channel.call("getTitle",[e])}isActiveElement(e,t){return this.channel.call("isActiveElement",[e,t])}getElements(e,t,n){return this.channel.call("getElements",[e,t,n])}getElementXY(e,t,n,s){return this.channel.call("getElementXY",[e,t,n,s])}typeInEditor(e,t,n){return this.channel.call("typeInEditor",[e,t,n])}getTerminalBuffer(e,t){return this.channel.call("getTerminalBuffer",[e,t])}writeInTerminal(e,t,n){
return this.channel.call("writeInTerminal",[e,t,n])}}t.DriverChannelClient=s;t.WindowDriverRegistryChannel=class{constructor(e){this.registry=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,n){switch(t){case"registerWindowDriver":return this.registry.registerWindowDriver(n);case"reloadWindowDriver":return this.registry.reloadWindowDriver(n)}throw new Error(`Call not found: ${t}`)}};t.WindowDriverRegistryChannelClient=class{constructor(e){this.channel=e}registerWindowDriver(e){return this.channel.call("registerWindowDriver",e)}reloadWindowDriver(e){return this.channel.call("reloadWindowDriver",e)}};t.WindowDriverChannel=class{constructor(e){this.driver=e}listen(e,t){throw new Error(`No event found: ${t}`)}call(e,t,n){switch(t){case"click":return this.driver.click(n[0],n[1],n[2]);case"doubleClick":return this.driver.doubleClick(n);case"setValue":return this.driver.setValue(n[0],n[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(n)
;case"getElements":return this.driver.getElements(n[0],n[1]);case"getElementXY":return this.driver.getElementXY(n[0],n[1],n[2]);case"typeInEditor":return this.driver.typeInEditor(n[0],n[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(n);case"writeInTerminal":return this.driver.writeInTerminal(n[0],n[1])}throw new Error(`Call not found: ${t}`)}};t.WindowDriverChannelClient=class{constructor(e){this.channel=e}click(e,t,n){return this.channel.call("click",[e,t,n])}doubleClick(e){return this.channel.call("doubleClick",e)}setValue(e,t){return this.channel.call("setValue",[e,t])}getTitle(){return this.channel.call("getTitle")}isActiveElement(e){return this.channel.call("isActiveElement",e)}getElements(e,t){return this.channel.call("getElements",[e,t])}getElementXY(e,t,n){return this.channel.call("getElementXY",[e,t,n])}typeInEditor(e,t){return this.channel.call("typeInEditor",[e,t])}getTerminalBuffer(e){return this.channel.call("getTerminalBuffer",e)}writeInTerminal(e,t){
return this.channel.call("writeInTerminal",[e,t])}},t.connect=async function(e){const t=await n.connect(e,"driverClient"),i=t.getChannel("driver");return{client:t,driver:new s(i)}}}))}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f359dd69833dd8800b54d458f6d37ab7c78df520/core/vs/platform/driver/node/driver.js.map
